/*************************************************************************
 
  16bit portion of 32->16 flat thunk for calling control panel applets 
             Copyright  Bryan Stafford, New Vision Software
 
*************************************************************************/

#include <windows.h>

// definition for CPlApplet function exported by all control panel applets                               
typedef DWORD (WINAPI *APPLET_PROC)(HWND hWndCpl, UINT msg, LONG lParam1, LONG lParam2);

// prototype for function in .obj file from the thunk script
BOOL WINAPI __export CPL32_ThunkConnect16(LPSTR lpDll16,
                                          LPSTR lpDll32,
                                          WORD  hInst,
                                          DWORD dwReason);
                                                         

// main dll entry point.  the CPL32_ThunkConnect16 function must be called 
// each time the the dll is initialized
BOOL WINAPI __export DllEntryPoint(DWORD dwReason,
                                         WORD  hInst,
                                         WORD  wDS,
                                         WORD  wHeapSize,
                                         DWORD dwReserved1,
                                         WORD  wReserved2)
{ 
    if( !(CPL32_ThunkConnect16( "CPL16.DLL",  // name of 16-bit DLL 
        "CPL32.DLL",                        // name of 32-bit DLL 
        hInst, dwReason)) ) 
    { 
        return FALSE; 
    } 
    return TRUE; 
}


// wrapper for the CPlApplet function exported by each control panel applet
DWORD WINAPI __export CPlApplet16(DWORD *lpfnCPlApplet,
								  DWORD *hWndCPL, 
								  DWORD *uMsg, 
								  LONG *lParam1, 
								  LONG *lParam2)
{
  	APPLET_PROC lpAppletProc = (APPLET_PROC) *lpfnCPlApplet;

    if (lpAppletProc != NULL)
    	return lpAppletProc((HWND) *hWndCPL, (UINT) *uMsg, *lParam1, *lParam2);   
    else
    	return 0;

}                           

// wrapper for the 16bit LoadString function
DWORD WINAPI __export LoadString16(DWORD *hInst,
								   DWORD *idResource, 
								   DWORD *lpszBuffer, 
								   DWORD *cbBuffer)
{	
    return (DWORD) LoadString( (HINSTANCE) *hInst, (UINT) *idResource, (LPSTR) *lpszBuffer, (int) *cbBuffer );
}                           

// wrapper for the 16bit LoadLibrary function
DWORD WINAPI __export LoadLibrary16(LPSTR lpszLibFileName)
{
   	return (DWORD) LoadLibrary( lpszLibFileName );            
}  

// wrapper for the 16bit FreeLibrary function
DWORD WINAPI __export FreeLibrary16(DWORD *hInst)
{                           
   	FreeLibrary( (HINSTANCE) *hInst );            
                                       
    return 1;
}     
   
// wrapper for the 16bit GetProcAddress function
DWORD WINAPI __export GetProcAddress16(DWORD *hInst)
{
   	return (DWORD) GetProcAddress( (HINSTANCE) *hInst, "CPlApplet" );
}