Attribute VB_Name = "MHelperFunctions"
  Option Explicit
  ' demo project that shows how to enumerate control panel applets.
  ' this project also shows how to create a thunking layer using C code
  ' and the thunk compiler ("Thunk.exe" found in the Win32 SDK tools) to
  ' allow the enumeration of 16bit applets on Win9x systems.  the thunk
  ' layer is not necessary for applet enumeration on NT systems.
  '
  ' for more info on thunking see the "Thunks.txt" or "Thunks.doc" file
  ' included in this demo package.
  '
  ' this was written by Bryan Stafford of New Vision Software - newvision@mvps.org.
  ' all of the code contained in this project is copyrighted.  see the
  ' "House Rules" setion at http://www.mvps.org/vbvision for info on the
  ' allowed usage of the contained code.
  '
  '               Copyright  2000  Bryan Stafford
  '
  ' I also wish to acknoledge the assistence provided by Brad Martines
  ' (http://www.mvps.org/btmtz) in the design and debugging of portions
  ' of this project.  Thanks Brad!
  '

Public Function GetOSVersion() As OS_VERSIONS
  ' returns the verson of the OS that we are running on
  
  Dim osInfo As OSVERSIONINFO
 
  osInfo.dwOSVersionInfoSize = Len(osInfo)
  
  If GetVersionEx(osInfo) Then
  
    With osInfo
      Select Case True
        Case (.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS) And (.dwMajorVersion = 4 And .dwMinorVersion = 0)
          GetOSVersion = osvWin95
          
        Case (.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS) And (.dwMajorVersion > 4) Or (.dwMajorVersion = 4 And .dwMinorVersion > 0)
          GetOSVersion = osvWin98
          
        Case (.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS) And (.dwMajorVersion = 4 And .dwMinorVersion = 90)
          GetOSVersion = osvWinME
        
        Case (.dwPlatformId = VER_PLATFORM_WIN32_NT) And (.dwMajorVersion = 4)
          GetOSVersion = osvWinNT4
        
        Case (.dwPlatformId = VER_PLATFORM_WIN32_NT) And (.dwMajorVersion = 5)
          GetOSVersion = osvWin2K
        
        Case Else
          GetOSVersion = osvError
             
      End Select
    End With
  End If
  
End Function

Public Function StripNulls(ByVal sText As String) As String
  ' strips any nulls from the end of a string
  Dim nPosition As Long
  
  StripNulls = sText
  
  nPosition = InStr(sText, vbNullChar)
  If nPosition Then StripNulls = Left$(sText, nPosition - 1)
  If Len(sText) Then If Left$(sText, 1) = vbNullChar Then StripNulls = vbNullString
End Function

