Attribute VB_Name = "M_API_Declares"
  Option Explicit
  ' see the general declares section of the CCPLFiles.cls module
  ' for more info about this project

  ' ################# declares for the 32bit API calls used directly on the applets #################################
  Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
  Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
  
  Public Declare Function GetProcAddress Lib "kernel32" _
                              (ByVal hModule As Long, _
                              lpProcName As Any) As Long
  
  Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  
  Public Declare Function LoadString Lib "user32" Alias "LoadStringA" _
                              (ByVal HINSTANCE As Long, _
                              ByVal uID As Long, _
                              lpBuffer As Any, _
                              ByVal nBufferMax As Long) As Long
  
  Public Declare Function lstrlenW Lib "kernel32" (lpString As Any) As Long
  
  Public Enum CPL_Msgs
    CPL_DYNAMIC_RES = 0
    CPL_INIT = 1
    CPL_GETCOUNT = 2
    CPL_INQUIRE = 3
    CPL_SELECT = 4
    CPL_DBLCLK = 5
    CPL_STOP = 6
    CPL_EXIT = 7
    CPL_NEWINQUIRE = 8
    CPL_STARTWPARMSA = 9
    CPL_STARTWPARMSW = 10
    CPL_SETUP = 200
  End Enum
  
  Public Type CPLINFO
    idIcon As Long    ' icon resource id, provided by CPlApplet()
    idName As Long   ' name string res. id, provided by CPlApplet()
    idInfo As Long      ' info string res. id, provided by CPlApplet()
    lData As Long      ' user defined data
  End Type
  
  Public Type NEWCPLINFOA
    dwSize As Long              ' struct size
    dwFlags As Long             ' ignored
    dwHelpContext As Long  ' help context to use (ignored?)
    lData As Long                  ' user defined data
    hIcon  As Long                ' icon ID (not HICON!!), this is owned by CONTROL.EXE (may be deleted)
    szName(31) As Byte        ' short name
    szInfo(63) As Byte           ' long name (status line)
    szHelpFile(127) As Byte   ' path to help file to use
  End Type
  
  Public Type NEWCPLINFOW
    dwSize As Long              ' struct size
    dwFlags As Long             ' ignored
    dwHelpContext As Long  ' help context to use (ignored?)
    lData As Long                  ' user defined data
    hIcon  As Long                ' icon ID (not HICON!!), this is owned by CONTROL.EXE (may be deleted)
    szName(63) As Byte        ' short name
    szInfo(127) As Byte          ' long name (status line)
    szHelpFile(255) As Byte   ' path to help file to use
  End Type
  
  Public Enum NEWCPLINFO_VERSION
    ANSI = 1&
    Wide
  End Enum
  
  ' #########################  declares required for 16bit thunk code  ###############################################
  Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes As Long)
  Public Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (lpDest As Any, ByVal cBytes As Long)
  
  Public Declare Function IsWindow Lib "user32" (ByVal hWnd&) As Long
  
  ' because of the way things are passed in the thunk calls, just about everything has to be passed ByRef
  Public Declare Function CPlApplet16 Lib "CPL32" (ByRef lpfnCPlApplet As Long, ByRef hWndCPL As Long, ByRef uMsg As Long, ByRef lParam1 As Long, ByRef lParam2 As Long) As Long
  Public Declare Function LoadLibrary16 Lib "CPL32" (ByVal lpszLibFileName As String) As Long
  Public Declare Sub FreeLibrary16 Lib "CPL32" (ByRef hInst As Long)
  Public Declare Function GetProcAddress16 Lib "CPL32" (ByRef hInst As Long) As Long
  Public Declare Function LoadString16 Lib "CPL32" (ByRef hInst As Long, ByRef idResource%, ByRef lpszBuffer As Long, ByRef cbBuffer As Long) As Long
  
  ' 16bit versions of the structs
  Public Type CPLINFO16
    idIcon As Integer    ' icon resource id, provided by CPlApplet()
    idName As Integer   ' name string res. id, provided by CPlApplet()
    idInfo As Integer      ' info string res. id, provided by CPlApplet()
    lData As Long      ' user defined data
  End Type
  
  Public Type NEWCPLINFO16
    dwSize As Long              ' struct size
    dwFlags As Long             ' ignored
    dwHelpContext As Long  ' help context to use (ignored?)
    lData As Long                  ' user defined data
    hIcon  As Integer                ' icon ID (not HICON!!), this is owned by CONTROL.EXE (may be deleted)
    szName(31) As Byte        ' short name
    szInfo(63) As Byte           ' long name (status line)
    szHelpFile(127) As Byte   ' path to help file to use
  End Type
  
  ' Global Memory Flags
  Public Const GMEM_FIXED As Integer = &H0
  Public Const GMEM_ZEROINIT As Integer = &H40
  
  Public Const GPTR As Integer = (GMEM_FIXED Or GMEM_ZEROINIT)
  
  ' thunk pointer resolution calls
  Public Declare Function WOWGlobalAllocLock16 Lib "Wow32" (ByVal wFlags As Integer, ByVal cb As Long, ByVal phMem As Long) As Long
  Public Declare Function WOWGlobalUnlockFree16 Lib "Wow32" (ByVal vpMem As Long) As Integer
  Public Declare Function WOWGetVDMPointerFix Lib "Wow32" (ByVal vp As Long, ByVal dwBytes As Long, ByVal fProtectedMode As Long) As Long
  Public Declare Sub WOWGetVDMPointerUnfix Lib "Wow32" (ByVal vp As Long)
  
  ' enum and declare for mapping 32bit handles to 16bit handles
  Public Enum WOW_HANDLE_TYPE
      WOW_TYPE_HWND
      WOW_TYPE_HMENU
      WOW_TYPE_HDWP
      WOW_TYPE_HDROP
      WOW_TYPE_HDC
      WOW_TYPE_HFONT
      WOW_TYPE_HMETAFILE
      WOW_TYPE_HRGN
      WOW_TYPE_HBITMAP
      WOW_TYPE_HBRUSH
      WOW_TYPE_HPALETTE
      WOW_TYPE_HPEN
      WOW_TYPE_HACCEL
      WOW_TYPE_HTASK
      WOW_TYPE_FULLHWND
  End Enum
  
  Public Declare Function WOWHandle16 Lib "Wow32" (ByVal Handle As Long, ByVal HandleType As WOW_HANDLE_TYPE) As Integer
  Public Declare Function WOWHandle32 Lib "Wow32" (ByVal Handle As Integer, ByVal HandleType As WOW_HANDLE_TYPE) As Long


  ' ###################  other support API declares  ########################

  Public Const MAX_PATH As Long = 260&
  
  Public Enum OS_VERSIONS
    osvError = 0&
    osvWin95
    osvWin98
    osvWinME
    osvWinNT4
    osvWin2K
  End Enum


  Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" _
                              (ByVal lpBuffer As String, _
                              ByVal uSize As Long) As Long
  
  Public Enum REGISTRY_KEYS
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
  End Enum

  Public Const KEY_ENUMERATE_SUB_KEYS As Long = &H8&
  Public Const KEY_QUERY_VALUE As Long = &H1&

  Public Const ERROR_SUCCESS As Long = 0&
  Public Const ERROR_NO_MORE_ITEMS As Long = 259&


  Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
  End Type

  Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
  Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
  Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey&, ByVal dwIndex&, ByVal lpValueName$, lpcbValueName&, ByVal lpReserved&, ByVal lpType&, ByVal lpData$, lpcbData&) As Long
  Public Declare Function RegQueryValueExStr Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal lpReserved&, lpType&, ByVal lpData As String, lpcbData&) As Long
  Public Declare Function RegQueryValueExInt Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal lpReserved&, lpType&, lpData As Long, lpcbData&) As Long
  Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

  Public Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName$, ByVal lpReturnedString$, ByVal nSize&, ByVal lpFileName$) As Long

  Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath$, ByVal lpszShortPath$, ByVal cchBuffer&) As Long

  Public Const VER_PLATFORM_WIN32s As Long = 0&
  Public Const VER_PLATFORM_WIN32_WINDOWS As Long = 1&
  Public Const VER_PLATFORM_WIN32_NT As Long = 2&

  Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
  End Type

  Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

  Public Type SHFILEINFO   ' shfi
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * MAX_PATH
    szTypeName As String * 80
  End Type
  
  ' SHGetFileInfo uFlags
  Public Const SHGFI_LARGEICON = &H0              ' sfi.hIcon is large icon
  Public Const SHGFI_SMALLICON = &H1              ' sfi.hIcon is small icon
  Public Const SHGFI_SYSICONINDEX = &H4000     ' sfi.iIcon is sys il icon index, rtns hImagelist
  
  Public Declare Function SHGetFileInfo Lib "shell32" Alias "SHGetFileInfoA" _
                                (ByVal pszPath As Any, _
                                ByVal dwFileAttributes As Long, _
                                psfi As SHFILEINFO, _
                                ByVal cbFileInfo As Long, _
                                ByVal uFlags As Long) As Long
  
  Public Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal himl As Long, lpcx As Long, lpcy As Long) As Long
  
  ' LoadImage/CopyImage uType param
  Public Const IMAGE_ICON = 1
  
  ' LoadImage/CopyImage fuLoad param
  Public Const LR_COPYFROMRESOURCE = &H4000
  Public Const LR_SHARED = &H8000&
  
  Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal HINSTANCE As Long, ByVal lpszName As Any, ByVal uType As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal fuLoad As Long) As Long
  ' CopyIcon does not allow size specification, where CopyImage/LR_COPYFROMRESOURCE does
  Public Declare Function CopyImage Lib "user32" (ByVal hImage As Long, ByVal uType As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal fuLoad As Long) As Long
  Public Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
  
  Public Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile$, ByVal nIconIndex&, phiconLarge&, phiconSmall&, ByVal nIcons&) As Long

  Public Const S_OK = 0    ' indicates successful HRESULT
  
  Public Type GUID    ' pguid, 16 bytes (128 bits)
    Data1 As Long      ' 4 bytes
    Data2 As Integer     ' 2 bytes
    Data3 As Integer     ' 2 bytes
    Data4(7) As Byte   ' 8 bytes, zero based
  End Type
  
  Public Type PICTDESC   ' pd
    cbSize As Long
    PicType As PictureTypeConstants
    hImage As Long    ' HBITMAP, HMETAFILE, HICON, HENHMETAFILE
    Data1 As Long      ' HBITMAP hpal, HMETAFILE xExt
    Data2 As Long      ' HMETAFILE yExt
  End Type
  
  Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" _
                                (pPictDesc As PICTDESC, _
                                RefIID As GUID, _
                                ByVal fPictureOwnsHandle As Long, _
                                ppvObj As StdPicture) As Long

