VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmEnumerateCPLApplets 
   Caption         =   "Control Panel applets demo"
   ClientHeight    =   4995
   ClientLeft      =   945
   ClientTop       =   1395
   ClientWidth     =   6945
   ClipControls    =   0   'False
   Icon            =   "frmEnumerateCPLApplets.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4995
   ScaleWidth      =   6945
   Begin ComctlLib.ListView ListView1 
      Height          =   2595
      Left            =   600
      TabIndex        =   0
      Top             =   690
      Width           =   4515
      _ExtentX        =   7964
      _ExtentY        =   4577
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin ComctlLib.ImageList ImageList2 
      Left            =   1980
      Top             =   3930
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
   Begin ComctlLib.ImageList ImageList1 
      Left            =   720
      Top             =   3900
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
   Begin VB.Menu mnuView 
      Caption         =   "&View"
      Begin VB.Menu mnuViewLargeIcons 
         Caption         =   "Lar&ge Icons"
      End
      Begin VB.Menu mnuViewSmallIcons 
         Caption         =   "S&mall Icons"
      End
      Begin VB.Menu mnuViewList 
         Caption         =   "&List"
      End
      Begin VB.Menu mnuViewReport 
         Caption         =   "&Detatils"
      End
      Begin VB.Menu mnuViewSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuViewRefresh 
         Caption         =   "&Refresh"
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "<popup menu>"
      Begin VB.Menu mnuPopupOpenModal 
         Caption         =   "Open &modal..."
      End
      Begin VB.Menu mnuPopupOpenNonModal 
         Caption         =   "Open &non-modal..."
      End
   End
End
Attribute VB_Name = "frmEnumerateCPLApplets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project that shows how to enumerate control panel applets.
  ' this project also shows how to create a thunking layer using C code
  ' and the thunk compiler ("Thunk.exe" found in the Win32 SDK tools) to
  ' allow the enumeration of 16bit applets on Win9x systems.  the thunk
  ' layer is not necessary for applet enumeration on NT systems.
  '
  ' for more info on thunking see the "Thunks.txt" or "Thunks.doc" file
  ' included in this demo package.
  '
  ' this was written by Bryan Stafford of New Vision Software - newvision@mvps.org.
  ' all of the code contained in this project is copyrighted.  see the
  ' "House Rules" setion at http://www.mvps.org/vbvision for info on the
  ' allowed usage of the contained code.
  '
  '               Copyright  2000  Bryan Stafford
  '
  ' I also wish to acknoledge the assistence provided by Brad Martines
  ' (http://www.mvps.org/btmtz) in the design and debugging of portions
  ' of this project.  Thanks Brad!
  '

Private Type POINTAPI   ' pt
  x As Long
  y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As Any) As Long  ' lpPoint As POINTAPI) As Long
'

  Private m_oCCPLFiles As CCPLFiles

Private Sub Form_Load()
  
  mnuPopup.Visible = False
  
  With Me
    .ScaleMode = vbPixels   ' for ListView1.ColumnHeaders.Width
    .Height = 480 * Screen.TwipsPerPixelX
    .Width = 640 * Screen.TwipsPerPixelY
    Call .Move((Screen.Width - .Width) * 0.5, (Screen.Height - .Height) * 0.5)
  End With
  
  With ImageList1
    .ImageHeight = 16
    .ImageWidth = 16
  End With
  
  With ImageList2
    .ImageHeight = 32
    .ImageWidth = 32
  End With
  
  With ListView1
    .BorderStyle = ccNone
    With .ColumnHeaders
      Call .Add(, , "Title", 120)
      Call .Add(, , "Description", 350)
      Call .Add(, , "Filename", 70)
      Call .Add(, , "Index", 30, lvwColumnRight)
      Call .Add(, , "16 bit?", 35)
      Call .Add(, , "Failed Init?", 50)
      Call .Add(, , "CPL Type", 70)
    End With
    .LabelEdit = lvwManual
    .Sorted = True   ' SortKey = 0, SortOrder = lvwAscending
  End With
  
  Call SwitchView(lvwReport)
  Me.Show
  
  Set m_oCCPLFiles = New CCPLFiles
  
  Call LoadApplets
  
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' destroy the applet object
  Set m_oCCPLFiles = Nothing
End Sub

Private Sub LoadApplets()
  
  Dim i&, nIcon&, li As ListItem

  Me.MousePointer = vbHourglass
  
  With m_oCCPLFiles
    For i = 0 To .Count - 1
      nIcon = AddImageListIcons(.FileName(i) & CStr(i), .SmallIcon(i), .LargeIcon(i))
      Set li = ListView1.ListItems.Add(, , .Title(i), nIcon, nIcon)
      
      li.Tag = i '<-- store the current index in the tag property of the listitem
      
      li.SubItems(1) = .Description(i)
      li.SubItems(2) = LCase$(.FileName(i))
      li.SubItems(3) = CStr(i)
      li.SubItems(4) = CStr(.Is16Bit(i))
      li.SubItems(5) = CStr(.FailedInit(i))
      Select Case .AppletType(i)
        Case cplInvalidApplet
          li.SubItems(6) = "invalid"
        Case cplNewInquireUnicode
          li.SubItems(6) = "new Unicode"
        Case cplNewInquireANSI
          li.SubItems(6) = "new ANSI"
        Case cplOldInquireANSI
          li.SubItems(6) = "old ANSI"
      End Select
    Next
  End With
        
  Me.MousePointer = vbNormal
  
End Sub

' sTag = "<CPL path>" & "<applet index>"

Private Function AddImageListIcons(sTag As String, picSmIcon As StdPicture, picLgIcon As StdPicture) As Long
  Dim li As ListImage
  
  On Error Resume Next
  Set li = ImageList1.ListImages(sTag)
  On Error GoTo Out
  
  If (li Is Nothing) Then
    Set li = ImageList1.ListImages.Add(, sTag, picSmIcon)
    Call ImageList2.ListImages.Add(, , picLgIcon)
  End If
  
  With ListView1
    If (.SmallIcons Is Nothing) Then Set .SmallIcons = ImageList1
    If (.Icons Is Nothing) Then Set .Icons = ImageList2
  End With
  
  AddImageListIcons = li.Index

Out:
End Function

Private Sub Form_Resize()
  If (WindowState <> vbMinimized) Then
    Call ListView1.Move(0, 0, ScaleWidth, ScaleHeight)
  End If
End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As ColumnHeader)
  Dim i As Integer
  
  With ListView1
    .Sorted = False
    ColumnHeader.Tag = Not Val(ColumnHeader.Tag)
    .SortOrder = Abs(Val(ColumnHeader.Tag))
    .SortKey = ColumnHeader.Index - 1
    .Sorted = True
  End With
    
End Sub

' ========================================================================
' applet execution

Private Sub ListView1_DblClick()
  Dim pt As POINTAPI
  
  Call GetCursorPos(pt)
  Call ScreenToClient(ListView1.hWnd, pt)
  Call ExecuteApplet(ListView1.HitTest(pt.x * Screen.TwipsPerPixelX, pt.y * Screen.TwipsPerPixelY))
  
End Sub

Private Sub ListView1_KeyPress(KeyAscii As Integer)
  If (KeyAscii = vbKeyReturn) Then
    Call ExecuteApplet(ListView1.SelectedItem)
  End If
End Sub

Private Sub ListView1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  If (Button = vbRightButton) Then
    If (ListView1.HitTest(x, y) Is Nothing) = False Then
      Call PopupMenu(mnuPopup, vbPopupMenuRightButton, , , mnuPopupOpenModal)
    End If
  End If
End Sub

Private Sub mnuPopupOpenModal_Click()
  Call ExecuteApplet(ListView1.SelectedItem)
End Sub

Private Sub mnuPopupOpenNonModal_Click()
  Call ExecuteApplet(ListView1.SelectedItem, False)
End Sub

Private Function ExecuteApplet(li As ListItem, Optional fModal As Boolean = True) As Boolean
  
  Dim sCmdLine As String
  
  If (li Is Nothing) = False Then
    With li
      If fModal Then
        ' note that some applets won't run as modal dialogs even if you supply an hWnd
        Call m_oCCPLFiles.DisplayApplet(Me.hWnd, .Tag)
      Else   ' non-modal
        ' see: "HOWTO: Start a Control Panel Applet in Windows 95, 98, or WinNT"
        ' http://support.microsoft.com/support/kb/articles/Q135/0/68.asp
        ' and/or: "How to Run Control Panel Tools by Typing a Command"
        ' http://support.microsoft.com/support/kb/articles/Q192/8/06.asp
        sCmdLine = "rundll32.exe shell32.dll,Control_RunDLL " & .SubItems(2) & ",@" & .SubItems(3)
        Call Shell(sCmdLine, vbNormalFocus)
      End If
    End With
  End If

End Function

' ========================================================================
' View menu

Private Sub mnuViewRefresh_Click()
  m_oCCPLFiles.Refresh
  Call ListView1.ListItems.Clear
  Call ListView1.Refresh
  Call LoadApplets
End Sub

Private Sub mnuViewLargeIcons_Click()
  Call SwitchView(lvwIcon)
End Sub

Private Sub mnuViewSmallIcons_Click()
  Call SwitchView(lvwSmallIcon)
End Sub

Private Sub mnuViewList_Click()
  Call SwitchView(lvwList)
End Sub

Private Sub mnuViewReport_Click()
  Call SwitchView(lvwReport)
End Sub

Private Sub SwitchView(dwNewView As ListViewConstants)
  
  ListView1.View = dwNewView
  ' A bug: http://support.microsoft.com/support/kb/articles/q143/4/06.asp
  ListView1.Arrange = lvwAutoTop
  
  mnuViewLargeIcons.Checked = (dwNewView = lvwIcon)
  mnuViewSmallIcons.Checked = (dwNewView = lvwSmallIcon)
  mnuViewList.Checked = (dwNewView = lvwList)
  mnuViewReport.Checked = (dwNewView = lvwReport)

End Sub

